
namespace TouhouSE {

namespace TH145 {

class Th145Extracter : public TH135::Th135ArchiveExtractorBase<Th145Extracter> {
public:
  Th145Extracter(
    std::unique_ptr<std::istream> in,
    std::map<unsigned int, std::shared_ptr<TH135::FileInfo> > hashToFileInfoMap,
    const unsigned int headerSize)
    :
    Th135ArchiveExtractorBase<Th145Extracter>(std::move(in), std::move(hashToFileInfoMap), headerSize)
  {}

  static unsigned int calcHash(const std::wstring &in, const unsigned int init = 0x811C9DC5) {
    const std::string temp = wStrToStr(normalize(in));
    // FNV1a
    return std::accumulate(temp.begin(), temp.end(), init, [](const unsigned int cur, const unsigned char c) {
      return (cur ^ c) * 0x1000193;
    });
  }

  static unsigned int calcHash(const std::string &in, const unsigned int init = 0x811C9DC5) {
    return calcHash(strToWStr(in), init);
  }
};

} // TH145

} // TouhouSE
